#include <csgo_colors>
#include <sdktools>
#include <shop>
#include <hgr>

int PH, SPH, HRU, HD
int HookUse[MAXPLAYERS+1];

ItemId idHook;

public Plugin myinfo = {
	name = "[Shop] Hook",
	description = "Hook for shop",
	author = "-=HellFire=-",
	version = "1.0",
	url = "VK: vk.com/insellx | HLMOD: hlmod.ru/members/hellfire.105029"
};

public void OnPluginStart()
{
	ConVar Cvar;

	HookConVarChange((Cvar = CreateConVar("sm_shop_hook_price", "10000", "Цена покупки паутинки")), PriceHook);
	PH = Cvar.IntValue;

	HookConVarChange((Cvar = CreateConVar("sm_shop_hook_sellprice", "5000", "Цена продажи паутинки")), SellPriceHook);
	SPH = Cvar.IntValue;

	HookConVarChange((Cvar = CreateConVar("sm_shop_hook_per_round", "3", "Макс. кол-во использований в раунде")), HookRoundUse);
	HRU = Cvar.IntValue;

	HookConVarChange((Cvar = CreateConVar("sm_shop_hook_duration", "604800", "Длительность паутинки в секундах (604800 - 1 неделя)")), HookDuration);
	HD = Cvar.IntValue;

	if (Shop_IsStarted()) Shop_Started();
	
	HookEvent("round_start", RoundStart, EventHookMode_PostNoCopy);
	
	AutoExecConfig(true, "shop_hook", "shop");
}

public void OnPluginEnd()
{ 
	Shop_UnregisterMe();
}

public void OnClientDisconnect(int client)
{
	HookUse[client] = 0;
}

public RoundStart(Handle event, const char[] name, bool donBroadcast)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		HookUse[i] = 0;
	}
}

public void Shop_Started()
{
	CategoryId CATEGORY = Shop_RegisterCategory("ability", "Способности", "");

	if(CATEGORY == INVALID_CATEGORY)
    {
        SetFailState("Failed to register category");
    }

	if (Shop_StartItem(CATEGORY, "hook"))
	{
		Shop_SetInfo("Паутинка", "Позволяет использовать паутинку (+hook)", PH, SPH, Item_Togglable, HD);
		Shop_SetCallbacks(OnRegisteredHook, OnItemHook, _, _, _, _, OnHookBuy, OnHookSell);
		Shop_EndItem();
	}
	else 
    {
    	SetFailState("Failed to register item");
    }
}

void OnRegisteredHook(CategoryId category_id, const char[] CATEGORY, const char[] item, ItemId item_id)
{
	idHook = item_id;
}

public int PriceHook(ConVar Cvar, const char[] szOldValue, const char[] szNewValue)
{
	PH = Cvar.IntValue;
}

public int SellPriceHook(ConVar Cvar, const char[] szOldValue, const char[] szNewValue)
{
    SPH = Cvar.IntValue;
}

public int HookRoundUse(ConVar Cvar, const char[] szOldValue, const char[] szNewValue)
{
	HRU = Cvar.IntValue;
}

public int HookDuration(ConVar Cvar, const char[] szOldValue, const char[] szNewValue)
{
	HD = Cvar.IntValue;
}

public bool OnHookBuy(int client, CategoryId category_id, const char[] CATEGORY, ItemId item_id, const char[] item, ItemType type, int price, int sell_price, int value)
{
	Shop_ToggleClientItem(client, idHook, Toggle_On);
	return true;
}

public bool OnHookSell(int client, CategoryId category_id, const char[] CATEGORY, ItemId item_id, const char[] item, ItemType type, int sell_price)
{
	HGR_ClientAccess(client, 1, 0);
	return true;
}

public ShopAction OnItemHook(int client, CategoryId category_id, const char[] CATEGORY, ItemId item_id, const char[] item, bool isOn, bool elapsed)
{
	if (isOn || elapsed)
	{
		HGR_ClientAccess(client, 1, 0);
		return Shop_UseOff;
	}
	HGR_ClientAccess(client, 0, 0);
	return Shop_UseOn;
}


public Action HGR_OnClientHook(int client)
{
  if (!HRU)
  {
    return Plugin_Continue;
  }

  if (HookUse[client] >= HRU)
  {
    CGOPrintToChat(client, "{GREEN}[Паутинка] {RED}Лимит паутинок исчерпан!");
    return Plugin_Handled;
  }

  HookUse[client]++;
  CGOPrintToChat(client, "{GREEN}[Паутинка] {RED}Осталось %d паутинок", HRU - HookUse[client]);
  return Plugin_Continue;
}
